<script setup lang="ts">
import { ref } from 'vue'
import { useI18n } from 'vue-i18n'
//import { useRouter } from 'vue-router'
import { useAppStore } from '../stores/AppStore'
import { useMemberStore } from '../stores/MemberStore'
//import Consts from '../Consts'

// using
const { t } = useI18n({
	messages: {
		en: {
			email: `Email`,
			password: `Password`,
			confirmPassword: `Confirm Password`,
			ok: `Register`,
			confirm: `Please confirm the sign-up by email: {mail}`,
		},
		th: {
			email: `อีเมล`,
			password: `รหัสผ่าน`,
			confirmPassword: `ยืนยันรหัสผ่าน`,
			ok: `ลงทะเบียน`,
			confirm: `โปรดยืนยันการสมัครสมาชิกทางอีเมล: {mail}`,
		},
	},
})
//const router = useRouter()
const appStore = useAppStore()
const memberStore = useMemberStore()

// states
const email = ref("")
const password = ref("")
const confirmPassword = ref("")

async function onSubmit() {
	// checks passwords must be equals
	if (password.value !== confirmPassword.value) {
		appStore.handleError(t('validator.isSamePasswords'))
		return
	}

	// calls REST
	const result = await appStore.waitBoxAsync(async () =>
		await memberStore.client.call(`member/signup`, {
			method: 'POST',
			data: {
				signUp: {
					mail: email.value.trim(),
					password: password.value,
					confirmPassword: confirmPassword.value,
				}
			},
		})
	)
	if (appStore.handleRestResultUi(result))
		return

	// success, retrieves REST data
	appStore.messageBoxInfo(t('confirm', { mail: email.value.trim() }))
	//router.go(-1)
}

</script>


<style scoped></style>


<template>
	<form id="signUpForm" @submit.prevent="onSubmit">
		<!-- email -->
		<div>
			<label for="email">{{ t('email') }}</label>
			<input id="email" type="email" :placeholder="t('email')" required v-model="email" />
		</div>

		<!-- password -->
		<div>
			<label for="password">{{ t('password') }}</label>
			<input id="password" type="password" :placeholder="t('password')" required minlength="4" maxlength="20"
				v-model="password" />
		</div>

		<!-- password -->
		<div>
			<label for="confirmPassword">{{ t('confirmPassword') }}</label>
			<input id="confirmPassword" type="Password" :placeholder="t('confirmPassword')" required minlength="4"
				maxlength="20" v-model="confirmPassword" />
		</div>

		<div>
			<button type="submit">{{ t('ok') }}</button>
		</div>
	</form>
</template>
